<template>
  <div class="container-fluid customer-list">
    <div class="row customer-list__title">
      <div class="col-12">
        <h1 class="title-name title-name--center">Customer List</h1>
      </div>
    </div>
    <div class="row customer-list__add-new">
      <div class="col-12">
        <!-- <b-button
          class="float-right add-new-btn add-new-btn--adjust-style"
          variant="primary"
          @click="$bvModal.show('add-new-customer')"
          id="show-btn"
          >Add new</b-button
        > -->
        <b-button
          class="float-right add-new-btn add-new-btn--adjust-style"
          variant="primary"
          @click="handleAddNewCustomer(-1)"
          id="show-btn"
          >Add new</b-button
        >
      </div>
    </div>
    <div class="row customer-list__table">
      <div class="col-12">
        <b-table
          responsive
          :items="customer_list"
          :fields="display_fields"
          :per-page="perPage"
          :current-page="currentPage"
          class="table table--center"
          striped
          hover
          v-if="customer_list.length > 0"
        >
          <template v-slot:cell(actions)="{ item }">
            <div class="table__cell table__cell--center">
              <b-button
                class="ml-1 mr-1 table__cell__btn"
                variant="success"
                @click="handleUpdateCustomer(item.id)"
                id="show-btn"
                >Update</b-button
              >
              <b-button
                id="show-btn"
                class="btn btn-primary ml-1 mr-1 table__cell__btn"
                variant="primary"
                @click="showViewCustomer(item.id)"
                >View</b-button
              >
              <a
                class="btn btn-danger ml-1 mr-1 table__cell__btn"
                @click.prevent="deleteCustomer(item.id, item.name)"
                >Delete</a
              >
            </div>
          </template>
        </b-table>
        <p class="status-text status-text--center" v-else>{{ status_text }}</p>
      </div>
      <div class="col-12">
        <b-pagination
          v-model="currentPage"
          pills
          :total-rows="rows"
          size="lg"
        ></b-pagination>
      </div>
    </div>
    <div class="row"></div>
    <!-- <div class="row customer-list__add-new-modal">
      <b-modal
        id="add-new-customer"
        class="add-new-customer"
        size="lg"
        title="Add new Customer"
        hide-footer
        no-stacking
      >
        <AddNewCustomerModal
          @hideAddNewModal="hideAddNewModal"
          @getCustomerList="getCustomerList"
        />
      </b-modal>
    </div> -->
    <div class="row customer-list__info-modal">
      <b-modal
        id="customer-info"
        class="customer-info"
        size="md"
        :title="getTitleModal()"
        hide-footer
        no-stacking
      >
        <UserInfoModal
          :id="id_reference"
          :action="action"
          @hideUserInfoModal="hideUserInfoModal"
          @getCustomerList="getCustomerList"
        />
      </b-modal>
    </div>
    <div class="row customer-list__view-customer-modal">
      <div class="col-12">
        <b-modal
          id="view-customer"
          class="view-customer"
          size="lg"
          title="Customer Info"
          ok-only
          hide-footer
          no-stacking
        >
          <ViewModal :id="id_reference" />
        </b-modal>
      </div>
    </div>
    <!-- <DeleteAll /> -->
  </div>
</template>

<script>
import "./scss/common.scss";
import "./scss/CustomerList.scss";
import axios from "axios";
import Swal from "sweetalert2";
import ViewModal from "./ViewModal.vue";
// import AddNewCustomerModal from "./AddNewCustomerModal.vue";
import UserInfoModal from "./UserInfoModal.vue";

export default {
  name: "CustomerList",
  props: {},
  components: {
    ViewModal,
    // AddNewCustomerModal,
    UserInfoModal,
},
  data: () => ({
    customer_list: [],
    status_text: "Customer list is empty!!!",
    id_reference: null,
    action: "update",
    display_fields: [
      "id",
      "name",
      "address",
      "balance",
      "email",
      "phoneNumber",
      "fax",
      "yearOfBirth",
      "Actions",
    ],
    // rows: 100,
    currentPage: 1,
    perPage: 20,
  }),
  methods: {
    showViewCustomer(id) {
      this.id_reference = id;
      this.$bvModal.show("view-customer");
    },
    deleteCustomer(id, name) {
      this.$swal({
        title: "Are you sure?",
        html: `Do you want to delete this customer <span style='font-weight: bold; color: #7066e0;'>"${name}"</span>?`,
        type: "warning",
        showCancelButton: true,
        confirmButtonText: "Confirm",
        cancelButtonText: "Cancel",
        showCloseButton: true,
        showLoaderOnConfirm: true,
      }).then(async (result) => {
        if (result.value) {
          console.log(`We implement delete user have id = ${id}`);
          // call API here
          var res = await axios.delete(
            `https://ahasoft-sample-apis.azurewebsites.net/Customer?id=${id}`
          );
          if (res.status === 200) {
            Swal.fire({
              title: `Delete customer "${name}" successfully!!!`,
              showClass: {
                popup: "animate__animated animate__fadeInDown",
              },
              hideClass: {
                popup: "animate__animated animate__fadeOutUp",
              },
            });
            this.getCustomerList(); // Container
          }
        } else {
          console.log("Cancel delete!!!");
        }
      });
    },
    async getCustomerList() {
      console.log("get customer list");
      var info_response = await axios.get(
        "https://ahasoft-sample-apis.azurewebsites.net/Customer"
      );
      console.log("info_response = ", info_response);
      if (info_response.status === 200) {
        this.customer_list = [...info_response.data];
        // console.log("this.customer_list = ", this.customer_list);
      } else {
        this.customer_list = [];
      }
    },
    hideAddNewModal() {
      this.$bvModal.hide("add-new-customer");
    },
    formatPhoneNumber(phoneNumber) {
      return phoneNumber.replace(/(\d{4})(\d{3})(\d{3})/, "$1.$2.$3");
    },
    formatFaxNumber(faxNumber) {
      return faxNumber.replace(/(\d{3})(\d{4})/, "$1.$2");
    },
    formatMoney(money) {
      // var formatObj = new Intl.NumberFormat('vi-VN', { style: 'currency', currency: 'VND' });
      var formatObj = new Intl.NumberFormat();
      return formatObj.format(money);
    },
    showUserInfoModal() {
      this.$bvModal.show("customer-info");
    },
    hideUserInfoModal() {
      this.$bvModal.hide("customer-info");
    },
    handleUpdateCustomer(id) {
      this.id_reference = id;
      this.action = "update";
      this.showUserInfoModal();
    },
    handleAddNewCustomer(id) {
      this.id_reference = id;
      this.action = "add_new";
      this.showUserInfoModal();
    },
    getTitleModal() {
      if (this.action == "update") {
        return "Update Customer";
      } else if (this.action == "add_new") {
        return "Add New Customer";
      }
    },
  },
  mounted() {
    this.getCustomerList(); // Container
  },
  computed: {
    rows() {
      return this.customer_list.length;
    },
  },
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
</style>
